﻿// <auto-generated />
using Data;
using Microsoft.EntityFrameworkCore;
using Microsoft.EntityFrameworkCore.Infrastructure;
using Microsoft.EntityFrameworkCore.Metadata;
using Microsoft.EntityFrameworkCore.Migrations;
using Microsoft.EntityFrameworkCore.Storage.ValueConversion;

namespace Data.Migrations
{
    [DbContext(typeof(ApplicationDbContext))]
    [Migration("20200718213315_Seed ")]
    partial class Seed
    {
        protected override void BuildTargetModel(ModelBuilder modelBuilder)
        {
#pragma warning disable 612, 618
            modelBuilder
                .HasAnnotation("ProductVersion", "3.1.6")
                .HasAnnotation("Relational:MaxIdentifierLength", 128)
                .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

            modelBuilder.Entity("Core.Domain.BaseUnit", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("int")
                        .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                    b.Property<string>("EnName")
                        .HasColumnType("nvarchar(max)");

                    b.Property<bool>("IsFormula")
                        .HasColumnType("bit");

                    b.Property<int>("MeasureDimensionId")
                        .HasColumnType("int");

                    b.Property<string>("Name")
                        .HasColumnType("nvarchar(max)");

                    b.Property<string>("Symbol")
                        .HasColumnType("nvarchar(max)");

                    b.HasKey("Id");

                    b.HasIndex("MeasureDimensionId");

                    b.ToTable("BaseUnits");

                    b.HasData(
                        new
                        {
                            Id = 1,
                            EnName = "Meter",
                            IsFormula = false,
                            MeasureDimensionId = 1,
                            Name = "متر",
                            Symbol = "m"
                        },
                        new
                        {
                            Id = 2,
                            EnName = "Gram",
                            IsFormula = false,
                            MeasureDimensionId = 2,
                            Name = "گرم",
                            Symbol = "g"
                        },
                        new
                        {
                            Id = 3,
                            EnName = "Ampere",
                            IsFormula = false,
                            MeasureDimensionId = 3,
                            Name = "آمپر",
                            Symbol = "A"
                        },
                        new
                        {
                            Id = 4,
                            EnName = "Second",
                            IsFormula = false,
                            MeasureDimensionId = 4,
                            Name = "ثانیه",
                            Symbol = "S"
                        },
                        new
                        {
                            Id = 5,
                            EnName = "Celsius",
                            IsFormula = true,
                            MeasureDimensionId = 5,
                            Name = "سلسیوس",
                            Symbol = "C"
                        });
                });

            modelBuilder.Entity("Core.Domain.MeasureDimension", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("int")
                        .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                    b.Property<string>("EnName")
                        .HasColumnType("nvarchar(max)");

                    b.Property<string>("Name")
                        .HasColumnType("nvarchar(max)");

                    b.HasKey("Id");

                    b.ToTable("MeasureDimensions");

                    b.HasData(
                        new
                        {
                            Id = 1,
                            EnName = "Length",
                            Name = "طول"
                        },
                        new
                        {
                            Id = 2,
                            EnName = "g",
                            Name = "جرم"
                        },
                        new
                        {
                            Id = 3,
                            EnName = "electric current",
                            Name = "جریان الکتریکی"
                        },
                        new
                        {
                            Id = 4,
                            EnName = "S",
                            Name = "زمان"
                        },
                        new
                        {
                            Id = 5,
                            EnName = "D",
                            Name = "دما"
                        });
                });

            modelBuilder.Entity("Core.Domain.Unit", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("int")
                        .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                    b.Property<int>("BaseUnitId")
                        .HasColumnType("int");

                    b.Property<string>("EnName")
                        .HasColumnType("nvarchar(max)");

                    b.Property<string>("FromBaseUnitFormula")
                        .HasColumnType("nvarchar(max)");

                    b.Property<string>("Name")
                        .HasColumnType("nvarchar(max)");

                    b.Property<double>("NumberOfBaseUnit")
                        .HasColumnType("float");

                    b.Property<string>("Symbol")
                        .HasColumnType("nvarchar(max)");

                    b.Property<string>("ToBaseUnitFormula")
                        .HasColumnType("nvarchar(max)");

                    b.HasKey("Id");

                    b.HasIndex("BaseUnitId");

                    b.ToTable("Units");

                    b.HasData(
                        new
                        {
                            Id = 1,
                            BaseUnitId = 1,
                            EnName = "Millimeter",
                            Name = "میلی متر",
                            NumberOfBaseUnit = 0.001,
                            Symbol = "mm"
                        },
                        new
                        {
                            Id = 2,
                            BaseUnitId = 1,
                            EnName = "Centimeter",
                            Name = "سانتی متر",
                            NumberOfBaseUnit = 0.01,
                            Symbol = "cm"
                        },
                        new
                        {
                            Id = 3,
                            BaseUnitId = 1,
                            EnName = "Kilometer",
                            Name = "کیلومتر",
                            NumberOfBaseUnit = 1000.0,
                            Symbol = "km"
                        },
                        new
                        {
                            Id = 4,
                            BaseUnitId = 2,
                            EnName = "Milligram",
                            Name = "میلی گرم",
                            NumberOfBaseUnit = 0.001,
                            Symbol = "mg"
                        },
                        new
                        {
                            Id = 5,
                            BaseUnitId = 2,
                            EnName = "Kilogram",
                            Name = "کیلو گرم",
                            NumberOfBaseUnit = 1000.0,
                            Symbol = "kg"
                        },
                        new
                        {
                            Id = 6,
                            BaseUnitId = 2,
                            EnName = "Tonne",
                            Name = "تن",
                            NumberOfBaseUnit = 1000000.0,
                            Symbol = "ton"
                        },
                        new
                        {
                            Id = 7,
                            BaseUnitId = 5,
                            EnName = "Kelvin",
                            FromBaseUnitFormula = "a + 273.15",
                            Name = "کلوین",
                            NumberOfBaseUnit = 0.0,
                            Symbol = "K",
                            ToBaseUnitFormula = "a - 273.15"
                        },
                        new
                        {
                            Id = 8,
                            BaseUnitId = 5,
                            EnName = "Fahrenheit",
                            FromBaseUnitFormula = "(a * 9/5) + 32",
                            Name = "فارنهایت",
                            NumberOfBaseUnit = 0.0,
                            Symbol = "F",
                            ToBaseUnitFormula = "(a - 32) * 5/9"
                        });
                });

            modelBuilder.Entity("Core.Domain.BaseUnit", b =>
                {
                    b.HasOne("Core.Domain.MeasureDimension", "MeasureDimension")
                        .WithMany("BaseUnits")
                        .HasForeignKey("MeasureDimensionId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();
                });

            modelBuilder.Entity("Core.Domain.Unit", b =>
                {
                    b.HasOne("Core.Domain.BaseUnit", "BaseUnit")
                        .WithMany("FactorUnits")
                        .HasForeignKey("BaseUnitId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();
                });
#pragma warning restore 612, 618
        }
    }
}
